{*******************************************************}
{                                                       }
{       eXpert Desktop                                  }
{                                                       }
{       Copyright (c) 1996,97 Sergey Orlik              }
{       - product manager of Borland Russia             }
{                                                       }
{*******************************************************}
unit XDPageEd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, TypInfo, XDKMain, XDKMenu, XDKGen, XDKSnips, XDPage, XDKExpt;

type
  TxdPageCustomModule = class(TCustomModule)
  public
    constructor Create(ARoot:TComponent); override;
    destructor Destroy; override;
    procedure ExecuteVerb(Index:integer); override;
    function getAttributes:TCustomModuleAttributes; override;
    function getVerb(Index:integer):string; override;
    function getVerbCount:integer; override;
    procedure Saving; override;
    procedure ValidateComponent(Component:TComponent); override;
  end;

procedure Register;

type
  TXDPageGen = class(TDataModule)
    XDPageCreator: TxdkModuleCreator;
    XDPageSnippet: TxdkSnippet;
    XDREpage: TxdkRepositoryExpert;
    function XDPageCreatorSourceWriting(UnitIdent, FormIdent,
      AncestorIdent: String): String;
    procedure XDREpageExecute(Sender: TObject);
  end;

var
  XDPageGen: TXDPageGen;

implementation

{$R *.DFM}

//================================================================================
// TxdPageCustomModule

constructor TxdPageCustomModule.Create(ARoot:TComponent);
begin
//  ShowMessage(ARoot.ClassName);
//  if TxdPage(ARoot).Designer<>nil then
//    ShowMessage('TxdPageCustomModule.Create:'+ARoot.Name);
//  if csDesigning in ARoot.ComponentState then
//    ShowMessage('DesignMode !');
  inherited Create(ARoot);

//  TxdPage(ARoot).Designer:=TCustomForm(ARoot.Owner).Designer;
//  TxdPageDesigner(TxdPage(ARoot).Designer).Page:=TxdPage(ARoot);
end;

destructor TxdPageCustomModule.Destroy;
begin
//  TxdPage(Root).Designer:=nil;
  inherited Destroy;
end;

procedure TxdPageCustomModule.ExecuteVerb(Index:integer);
begin
end;

function TxdPageCustomModule.getAttributes:TCustomModuleAttributes;
begin
  Result:=[];
end;

function TxdPageCustomModule.getVerb(Index:integer):string;
begin
end;

function TxdPageCustomModule.getVerbCount:integer;
begin
  Result:=0;
end;

procedure TxdPageCustomModule.Saving;
begin
end;

procedure TxdPageCustomModule.ValidateComponent(Component:TComponent);
begin
//  if Component is TMainMenu then
//  if (Root as TxdPage).Designer<>nil then
//    ShowMessage('ValidateComponent:'+Root.ClassName);
end;

procedure Register;
begin
  RegisterCustomModule(TxdPage, TxdPageCustomModule);
end;


//================================================================================
// TXDPageGen

function TXDPageGen.XDPageCreatorSourceWriting(UnitIdent, FormIdent,
  AncestorIdent: String): String;
begin
   XDPageSnippet.ParamValues['UnitName']:=UnitIdent;
   XDPageSnippet.ParamValues['PageName']:=FormIdent;
   XDPageSnippet.DoResultCode;
   Result:=XDPageSnippet.ResultCodeText;
end;


procedure TXDPageGen.XDREpageExecute(Sender: TObject);
begin
  XDPageCreator.ModuleCreate;
end;

initialization
  xdkInitModule(TXDPageGen,XDPageGen);
finalization
  xdkDoneModule(XDPageGen);
end.
