{*******************************************************}
{                                                       }
{       eXpert Development Kit                          }
{                                                       }
{       Copyright (c) 1996,97 Sergey Orlik              }
{       - product manager of Borland Russia             }
{                                                       }
{*******************************************************}
unit XDKModEd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  XDKMain, XDKExpt, XDKSnips, XDKGen;

type
  TXDKModuleGen = class(TDataModule)
    XDKREmodule: TxdkRepositoryExpert;
    XDKModCreator: TxdkModuleCreator;
    XDKModSnippet: TxdkSnippet;
    procedure XDKREmoduleExecute(Sender: TObject);
    function XDKModCreatorSourceWriting(UnitIdent, FormIdent,
      AncestorIdent: String): String;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  XDKModuleGen: TXDKModuleGen;

implementation

{$R *.DFM}


procedure TXDKModuleGen.XDKREmoduleExecute(Sender: TObject);
begin
  XDKModCreator.ModuleCreate;
end;

function TXDKModuleGen.XDKModCreatorSourceWriting(UnitIdent, FormIdent,
  AncestorIdent: String): String;
begin
   XDKModSnippet.ParamValues['UnitName']:=UnitIdent;
   XDKModSnippet.ParamValues['ModuleName']:=FormIdent;
   XDKModSnippet.DoResultCode;
   Result:=XDKModSnippet.ResultCodeText;
end;

initialization
  xdkInitModule(TXDKModuleGen,XDKModuleGen);
finalization
  xdkDoneModule(XDKModuleGen);
end.
