{*******************************************************}
{                                                       }
{       eXpert Development Kit                          }
{                                                       }
{       Copyright (c) 1996,97 Sergey Orlik              }
{       - product manager of Borland Russia             }
{                                                       }
{*******************************************************}
unit XDKReg;

interface
uses
  SysUtils, Classes, Menus, DsgnIntf,
  XDKExpt, XDKMenu, XDKSteps, XDKStpEd, XDKSnips,
  XDKMnuEd, XDKNotif, XDKGen;


procedure Register;

//=====================================================================
implementation
{$R XDKEXPT.DCR}
{$R XDKMENU.DCR}
{$R XDKNOTIF.DCR}
{$R XDKSNIPS.DCR}
{$R XDKGEN.DCR}

//=====================================================================
// Register
procedure Register;
begin
// register Steps
  RegisterComponents('XDK', [TxdkSteps]);
  RegisterClasses([TxdkStepTab]);
  RegisterComponentEditor(TxdkSteps, TxdkStepPagesEditor);
  RegisterComponentEditor(TxdkStepTab, TxdkStepPagesEditor);

// register general XDK components
  RegisterComponents('XDK',
   [TxdkStandardExpert, TxdkRepositoryExpert, TxdkAddInMenu,
    TxdkAddInNotifier, {TxdkProjectNotifier, TxdkModuleNotifier,}
    TxdkSnippet,TxdkProjectCreator,TxdkModuleCreator]);
  RegisterNoIcon([TxdkAddInMenuItem]);
  RegisterComponentEditor(TxdkAddInMenu,TxdkAddInMenuEditor);
  RegisterPropertyEditor(TypeInfo(string), TxdkAddInMenu, 'IDEMenuItem', TxdkIDEMenuItemProperty);
  RegisterPropertyEditor(TypeInfo(TxdkAddInMenuItem), TxdkAddInMenu, 'Items',
    TxdkAddInMenuItemProperty);
end;

end.
